#much of this is cribbed from CMFCalender/Extensions/Install.py.  Most of it really.

from Products.CMFCore.TypesTool import ContentFactoryMetadata
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName, ToolInit
from Products.PABlog import BlogEntry, blog_globals
from Acquisition import aq_base
from cStringIO import StringIO
import string


def install(self):
    " Register PABlog "
    out = StringIO()
    typestool = getToolByName(self, 'portal_types')
    skinstool = getToolByName(self, 'portal_skins')
    metadatatool = getToolByName(self, 'portal_metadata')
    catalog = getToolByName(self, 'portal_catalog')
    portal_url = getToolByName(self, 'portal_url')

    base = aq_base(catalog)
    if hasattr(base, 'addIndex'):
        # Zope 2.4
        addIndex = catalog.addIndex
    else:
        # Zope 2.3 and below
        addIndex = catalog._catalog.addIndex
    if hasattr(base, 'addColumn'):
        # Zope 2.4
        addColumn = catalog.addColumn
    else:
        # Zope 2.3 and below
        addColumn = catalog._catalog.addColumn
    try:
        addIndex('start', 'FieldIndex')
    except: pass
    try:
        addIndex('end', 'FieldIndex')
    except: pass
    try:
        addColumn('start')
    except: pass
    try:
        addColumn('end')
    except: pass
    out.write('Added "start" and "end" field indexes and columns to '\
              'the portal_catalog\n')


    for t in BlogEntry.factory_type_information:
        if t['id'] not in typestool.objectIds():
            cfm = apply(ContentFactoryMetadata, (), t)
            typestool._setObject(t['id'], cfm)
            out.write('Registered with the types tool\n')
        else:
            out.write('Object "%s" already existed in the types tool\n' % (
                t['id']))

    # Setup a MetadataTool Element Policy for Events
    try:
        metadatatool.addElementPolicy(
            element='Subject',
            content_type='PABlog',
            is_required=0,
            supply_default=0,
            default_value='',
            enforce_vocabulary=0,
            allowed_vocabulary=('Work'),
            REQUEST=None,
            )
    except: pass
    out.write('BlogEntry added to Metadata element Policies\n')
    

    p = portal_url.getPortalObject()
    x = p.manage_addProduct['PABlog']#.manage_addTool(type="PABlog")
    
    # Setup the skins
    # This is borrowed from CMFDefault/scripts/addImagesToSkinPaths.pys
    if 'PABlog' not in skinstool.objectIds():
        # We need to add Filesystem Directory Views for any directories
        # in our skins/ directory.  These directories should already be
        # configured.
        addDirectoryViews(skinstool, 'skins', blog_globals)
        out.write("Added 'PABlog' directory view to portal_skins\n")

    # Now we need to go through the skin configurations and insert
    # 'calendar' into the configurations.  Preferably, this should be
    # right before where 'content' is placed.  Otherwise, we append
    # it to the end.
    skins = skinstool.getSkinSelections()
    for skin in skins:
        path = skinstool.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        if 'PABlog' not in path:
            try: path.insert(path.index('topic'), 'PABlog_zpt')
            except ValueError:
                path.append('PABlog_zpt')
                
            try: path.insert(path.index('zpt_topic'), 'PABlog_zpt')
            except ValueError:
                pass
            
            path = string.join(path, ', ')
            # addSkinSelection will replace exissting skins as well.
            skinstool.addSkinSelection(skin, path)
            out.write("Added 'PABlog' to %s skin\n" % skin)
        else:
            out.write("Skipping %s skin, 'PABlog' is already set up\n" % (
                skin))

    return out.getvalue()

